package com.baidu.cloud.videoplayer.demo;

import java.util.ArrayList;
import java.util.List;
import java.util.Timer;
import java.util.TimerTask;

import com.baidu.cloud.media.download.DownloadableVideoItem;
import com.baidu.cloud.media.download.VideoDownloadManager;
import com.baidu.cloud.media.player.BDCloudMediaPlayer;
import com.baidu.cloud.media.player.IMediaPlayer;
import com.baidu.cloud.media.player.feature.FeatureException;
import com.baidu.cloud.media.player.feature.FeatureManager;
import com.baidu.cloud.videoplayer.demo.bar.AdvancedMediaController;
import com.baidu.cloud.videoplayer.demo.db.DBManager;
import com.baidu.cloud.videoplayer.demo.db.MediaBean;
import com.baidu.cloud.videoplayer.demo.helper.CommonUtils;
import com.baidu.cloud.videoplayer.demo.info.DownloadObserverManager;
import com.baidu.cloud.videoplayer.demo.info.SampleObserver;
import com.baidu.cloud.videoplayer.demo.info.SharedPrefsStore;
import com.baidu.cloud.videoplayer.demo.info.VideoInfo;
import com.baidu.cloud.videoplayer.demo.popview.FullScreenUtils;
import com.baidu.cloud.videoplayer.demo.service.BackgroundPlayService;
import com.baidu.cloud.videoplayer.widget.BDCloudVideoView;
import com.baidu.cloud.videoplayer.widget.BDCloudVideoView.PlayerState;
import com.baidu.cloud.videoplayer.demo.danmu.DefaultDanmuView;
import com.baidu.cloud.videoplayer.widget.DefaultGestureView;
import com.bumptech.glide.Glide;
import com.bumptech.glide.load.engine.DiskCacheStrategy;

import android.annotation.TargetApi;
import android.app.Activity;
import android.app.PictureInPictureParams;
import android.content.BroadcastReceiver;
import android.content.ComponentName;
import android.content.Context;
import android.content.Intent;
import android.content.IntentFilter;
import android.content.ServiceConnection;
import android.content.pm.ActivityInfo;
import android.content.pm.PackageManager;
import android.content.res.Configuration;
import android.graphics.PixelFormat;
import android.graphics.Rect;
import android.graphics.RectF;
import android.net.ConnectivityManager;
import android.net.Network;
import android.net.NetworkCapabilities;
import android.net.NetworkRequest;
import android.os.Build;
import android.os.Bundle;
import android.os.IBinder;
import android.os.PowerManager;
import android.os.SystemClock;
import android.text.TextUtils;
import android.util.Log;
import android.util.Rational;
import android.view.OrientationEventListener;
import android.view.View;
import android.view.View.OnClickListener;
import android.view.Window;
import android.view.WindowManager;
import android.widget.ImageButton;
import android.widget.ImageView;
import android.widget.RelativeLayout;
import android.widget.ScrollView;
import android.widget.TextView;
import android.widget.Toast;

public class AdvancedPlayActivity extends Activity implements IMediaPlayer.OnPreparedListener,
        IMediaPlayer.OnCompletionListener, IMediaPlayer.OnErrorListener,
        IMediaPlayer.OnInfoListener, IMediaPlayer.OnBufferingUpdateListener,
        IMediaPlayer.OnSEIListener,  IMediaPlayer.OnVideoSizeChangedListener,
        IMediaPlayer.OnHlsSegmentRequestListener, AdvancedMediaController.OnCastStateListener,
        BDCloudVideoView.OnPlayerStateListener, BDCloudVideoView.OnVideoRenderSurfaceListener {
    private static final String TAG = "AdvancedPlayActivity";

    /**
     * 您的AK 请到http://console.bce.baidu.com/iam/#/iam/accesslist获取
     */
    private String ak = ""; // 请录入您的AK !!!

    private String cuid = "";

    private VideoInfo info;
    private MediaBean mNowPlaying;
    private ArrayList<VideoInfo> playList;
    /**
     * drm版权保护 drmToken的生成与使用方式，请联系百度客服。 使用时，搜索该类中涉及drmToken的地方，酌情修改。
     */
    // private String drmToken =
    // "100a44b2c672011782cc64152dd71b4f9ca7821ea46191ce71e003eb5039468b_vod-gaqrms5ix6xad5yk_1471004113";

    private BDCloudVideoView mVV = null;
    private AdvancedMediaController mediaController = null;
    private ImageView preImageView = null;
    private TextView timeView = null;
    private TextView topTitleView = null;
    private RelativeLayout headerBar = null;
    private RelativeLayout fullHeaderRl = null;
    private RelativeLayout fullControllerRl = null;
    private RelativeLayout normalHeaderRl = null;
    private RelativeLayout normalControllerRl = null;

    private TextView debugInfoTextView;
    private ScrollView debugInfoScrollView;
    private long bufferingStartTimeMs;

    private RelativeLayout mRoot = null;
    private RelativeLayout mViewHolder = null;

    private Timer barTimer;
    private volatile boolean isFullScreen = false;

    private boolean bPreparing = true;
    private boolean bPlaybackCompleted = false;

    private DefaultDanmuView mDanmuView;
    private DefaultGestureView mGestureView;

    private ImageView mLockScreen;
    private boolean bLocked;
    private OrientationEventListener mOrientationEventListener;
    private int mOrientation;
    private long mLastOrientationTime;

    private TextView mPipBtn;
    private PictureInPictureParams.Builder mPictureInPictureParamsBuilder;
    private static final String ACTION_MEDIA_CONTROL = "media_control";
    private static final String EXTRA_CONTROL_TYPE = "control_type";
    private static final int CONTROL_TYPE_PLAY = 1;
    private static final int CONTROL_TYPE_PAUSE = 2;
    private BroadcastReceiver mPipReceiver;
    private boolean bActivityStopped = false;

    private TextView mDisableVideoBtn;
    private boolean bVideoDisabled;
    private ImageView mMusicIcon;
    private BackgroundPlayService.BackgroundPlayBinder mBgPlayBinder;
    private BackgroundPlayService mBgPlayService;
    private boolean bServiceBound;

    private TextView mErrorView;

    @TargetApi(Build.VERSION_CODES.LOLLIPOP)
    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        getWindow().addFlags(WindowManager.LayoutParams.FLAG_KEEP_SCREEN_ON);

        setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);
        enableOrientationListener();

        // 设置状态栏颜色
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.LOLLIPOP) {
            Window window = this.getWindow();
            window.clearFlags(WindowManager.LayoutParams.FLAG_TRANSLUCENT_STATUS);
            window.addFlags(WindowManager.LayoutParams.FLAG_DRAWS_SYSTEM_BAR_BACKGROUNDS);
            // finally change the color
            window.setStatusBarColor(0xff282828);
        }
        /**
         * 防闪屏
         */
        getWindow().setFormat(PixelFormat.TRANSLUCENT);

        setContentView(R.layout.activity_advanced_video_playing);
        PowerManager pm = (PowerManager) getSystemService(Context.POWER_SERVICE);
        listenToNetworkChange();

        info = getIntent().getParcelableExtra("videoInfo");

        for (int i = 0; i < info.getPreImages().length; ++i) {
            Glide.with(this)
                    .load(info.getPreImages()[i])
                    .diskCacheStrategy(DiskCacheStrategy.SOURCE)
                    .preload();
        }

        initUI();
    }

    @Override
    protected void onNewIntent(Intent intent) {
        Log.i(TAG, "onNewIntent");
        super.onNewIntent(intent);
        VideoInfo newInfo = intent.getParcelableExtra("videoInfo");
        if (newInfo != null) {
            if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.N
                    && isInPictureInPictureMode()) {
                if (!newInfo.getUrl().equals(info.getUrl())) {
                    info = newInfo;
                    tryToPlayOther();
                }
            } else {
                info = newInfo;
                tryToPlayOther();
            }
        }
    }

    /**
     * 初始化界面
     */
    private void initUI() {
        mRoot = findViewById(R.id.root);
        mViewHolder = findViewById(R.id.view_holder);
        mediaController = findViewById(R.id.media_controller_bar);
        preImageView = findViewById(R.id.preview_image);
        timeView = findViewById(R.id.time_view);
        fullHeaderRl = findViewById(R.id.rl_fullscreen_header);
        fullControllerRl = findViewById(R.id.rl_fullscreen_controller);
        normalHeaderRl = findViewById(R.id.rl_normalscreen_header);
        normalControllerRl = findViewById(R.id.rl_normalscreen_controller);
        headerBar = findViewById(R.id.rl_header_bar);

        debugInfoTextView = findViewById(R.id.info_text_view);
        debugInfoScrollView = findViewById(R.id.info_scrollView);

        /**
         * 设置ak
         */
        BDCloudVideoView.setAK(ak);

        /**
         * 设置appId（licensId）
         */
        BDCloudVideoView.setAppId(BaseApp.APP_ID);

        // 由宿主传入自定义的CustomID(cuid)信息，该字段将用于视频Qos,可不设置或传空
        BDCloudVideoView.setCuid(cuid);

        prepareVideoViewForHdrAndVR(info);

        mVV = new BDCloudVideoView(this);
        /**
         * 注册listener
         */
        mVV.setOnPreparedListener(this);
        mVV.setOnCompletionListener(this);
        mVV.setOnErrorListener(this);
        mVV.setOnInfoListener(this);
        mVV.setOnBufferingUpdateListener(this);
        mVV.setOnPlayerStateListener(this);
        mVV.setOnSEIListener(this);
        mVV.setOnVideoSizeChangedListener(this);
        mVV.setOnVideoRenderSurfaceChanged(this);
        // 是否开启"边播边缓存"功能
        mVV.setVideoCacheEnabled(SharedPrefsStore.getBooleanData(getApplicationContext(), C.KEY_VIDEOCACHE_SWITCH),
                null);
        // 处理HLS分片请求回调，在回调中可以修改分片请求地址
        mVV.setOnHlsSegmentRequestListener(this);

         // 无缝切换相关,若使用无缝切换则需设置媒体类型
        int switchType = info.getSwitchMode();
        mVV.setMediaSwitchType(switchType);

         // 若为mov类型需传入各清晰度媒体列表，及其媒体描述信息
        if (switchType == BDCloudMediaPlayer.SOURCE_SWITCH_SMOOTH_MODE) {
            mVV.setMediaItems(info.getInputList(), info.getMediasDes());
        }

        setScaleModeForVR(info, mVV);

        if (SharedPrefsStore.getBooleanData(getApplicationContext(), C.KEY_LOOPPlAY_SWITCH)) {
            mVV.setLooping(true);
        } else {
            mVV.setLooping(false);
        }

        RelativeLayout.LayoutParams rllp = new RelativeLayout.LayoutParams(-1, -1);
        rllp.addRule(RelativeLayout.CENTER_IN_PARENT);
        mViewHolder.addView(mVV, 0, rllp);
        mediaController.setMediaPlayerControl(mVV);
        mediaController.setViewImage(preImageView, info.getPreImages());
        mediaController.setTextView(timeView);
        mediaController.setOnCastStateListener(this);
        mVV.setTimeoutInUs(10 * 1000 * 1000);

        setInitStartPosIfNeeded();

        mVV.setVideoPath(info.getUrl());
        mVV.setLogEnabled(false);

        mVV.setMaxProbeTimeInMs(2000); // 设置最大探测时长

//        mVV.setMaxProbeSize(1 * 2048); // 设置最大探测的数据大小
//        mVV.setMaxCacheSizeInBytes(32 * 1024 * 1024); // 设置最大缓存数据大小
//        mVV.setBufferTimeInMs(100); // 设置缓冲事件发生时，缓存多长时间的数据才结束

//        mVV.toggleFrameChasing(true); // 设置是否开启直播追帧播放功能

        // 初始化好之后立即播放（您也可以在onPrepared回调中调用该方法）
        bPreparing = true;
        bPlaybackCompleted = false;
        mVV.start();
        initOtherUI();
    }

    private void initOtherUI() {
        // header
        final ImageButton ibBack = (ImageButton) this.findViewById(R.id.ibtn_back);
        ibBack.setOnClickListener(new OnClickListener() {

            @Override
            public void onClick(View v) {
                if (bLocked) {
                    return;
                }
                finish();
            }

        });
        RelativeLayout rlback = (RelativeLayout) this.findViewById(R.id.rl_back);
        rlback.setOnClickListener(new OnClickListener() {

            @Override
            public void onClick(View v) {
                ibBack.performClick();
            }

        });
        topTitleView = (TextView) this.findViewById(R.id.tv_top_title);
        topTitleView.setText(info.getTitle());
        final ImageButton ibScreen = (ImageButton) this.findViewById(R.id.ibtn_screen_control);
        ibScreen.setOnClickListener(new OnClickListener() {

            @Override
            public void onClick(View v) {
                if (bLocked) {
                    return;
                }
                if (isFullScreen) {
                    changeToPortrait();
                    ibScreen.setBackgroundResource(R.drawable.btn_to_fullscreen);
                } else {
                    changeToLandscape(false);
                    ibScreen.setBackgroundResource(R.drawable.btn_to_mini);
                    hideOuterAfterFiveSeconds();
                }
            }

        });
        mediaController.setNextListener(new OnClickListener() {

            @Override
            public void onClick(View v) {
                // fetch the next video. 为了demo的简便性，仅从主页列表获取
                if (playList == null) {
                    playList = SharedPrefsStore.getAllMainVideoFromSP(getApplicationContext());
                }
                int i = 0;
                int length = playList.size();
                for (i = 0; i < length; ++i) {
                    VideoInfo fInfo = playList.get(i);
                    if (fInfo.getUrl().equals(info.getUrl()) && fInfo.getTitle().equals(info.getTitle())) {
                        break;
                    }
                }
                if (i == length - 1) {
                    // is already the last one
                    Toast.makeText(getApplicationContext(), "已经是最后一个", Toast.LENGTH_SHORT).show();
                } else if (i < length - 1) {
                    // set the next info
                    info = playList.get(i + 1);
                    tryToPlayOther();
                } else {
                    // i >= length, should not come in
                    Log.d(TAG, "i >= length, should not come in");
                }
            }

        });
        mediaController.setPreListener(new OnClickListener() {

            @Override
            public void onClick(View v) {
                // fetch the pre video. 为了demo的简便性，仅从主页列表获取
                if (playList == null) {
                    playList = SharedPrefsStore.getAllMainVideoFromSP(getApplicationContext());
                }
                int i = 0;
                int length = playList.size();
                for (i = 0; i < length; ++i) {
                    VideoInfo fInfo = playList.get(i);
                    if (fInfo.getUrl().equals(info.getUrl()) && fInfo.getTitle().equals(info.getTitle())) {
                        break;
                    }
                }
                if (i == 0) {
                    // is already the first one
                    Toast.makeText(getApplicationContext(), "已经是第一个", Toast.LENGTH_SHORT).show();
                } else if (i < length) {
                    // set the next info
                    info = playList.get(i - 1);
                    tryToPlayOther();
                } else {
                    // i >= length, should not come in
                    Log.d(TAG, "i >= length, should not come in");
                }
            }

        });

        mediaController.setDownloadListener(new OnClickListener() {

            @Override
            public void onClick(View v) {
                if (info.getUrl().startsWith("file://")) {
                    Toast.makeText(AdvancedPlayActivity.this, "该资源已经是本地文件", Toast.LENGTH_SHORT).show();
                    return;
                } else if (!info.getUrl().endsWith(".m3u8")) {
                    Toast.makeText(AdvancedPlayActivity.this, "抱歉，当前仅支持m3u8资源的下载", Toast.LENGTH_SHORT).show();
                    return;
                }
                VideoDownloadManager downloadManagerInstance = VideoDownloadManager
                        .getInstance(AdvancedPlayActivity.this, SampleListActivity.SAMPLE_USER_NAME);
                DownloadableVideoItem item = downloadManagerInstance
                        .getDownloadableVideoItemByUrl(info.getUrl());
                if (item != null) {
                    // already
                    Toast.makeText(AdvancedPlayActivity.this, "该资源已经在缓存列表，请到「本地缓存」查看", Toast.LENGTH_SHORT).show();
                } else {
                    SharedPrefsStore.addToCacheVideo(AdvancedPlayActivity.this, info);
                    SampleObserver sampleObs = new SampleObserver();
                    DownloadObserverManager.addNewObserver(info.getUrl(), sampleObs);
                    downloadManagerInstance.startOrResumeDownloader(info.getUrl(), sampleObs);
                    Toast.makeText(AdvancedPlayActivity.this, "开始缓存，可到「本地缓存」查看进度", Toast.LENGTH_SHORT).show();
                }
            }

        });

        if (SharedPrefsStore.getIntData(this, C.KEY_ORIENT_TYPE, C.ORIENT_PORTRAIT)
                == C.ORIENT_HORIZONTAL) {
            ibScreen.performClick();
        }

        mDanmuView = new DefaultDanmuView(this, this.getResources().openRawResource(R.raw.comments));
        mDanmuView.hide();
        mViewHolder.addView(mDanmuView);
        mediaController.setDanmuControl(mDanmuView);

        mGestureView = findViewById(R.id.gesture_view);
        mGestureView.setOnGestureClickListener(new DefaultGestureView.OnGestureViewClickListener() {
            @Override
            public void onGestureViewClick() {
                onClickEmptyArea(null);
            }
        });
        mGestureView.setMediaController(mediaController);

        bLocked = false;
        mLockScreen = findViewById(R.id.lock_image);
        mLockScreen.setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View v) {
                bLocked = !bLocked;
                mLockScreen.setSelected(bLocked);
                mediaController.toggleLock();
            }
        });

        mPipBtn = findViewById(R.id.btn_pip);
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.O) {
            mPictureInPictureParamsBuilder =
                    new PictureInPictureParams.Builder();
        }
        mPipBtn.setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View v) {
                if (!bLocked) {
                    if (Build.VERSION.SDK_INT < Build.VERSION_CODES.N) {
                        Toast.makeText(getApplicationContext(), "当前设备不支持小窗", Toast.LENGTH_SHORT).show();
                        return;
                    }
                    boolean supportsPIP =
                            getApplicationContext().getPackageManager()
                                    .hasSystemFeature(PackageManager.FEATURE_PICTURE_IN_PICTURE);
                    if (!supportsPIP) {
                        Toast.makeText(getApplicationContext(), "当前设备不支持小窗", Toast.LENGTH_SHORT).show();
                        return;
                    }
                    if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.O) {
                        Rational aspectRatio;
                        if (mVV.getVideoWidth() > 0 && mVV.getVideoHeight() > 0) {
                            aspectRatio = new Rational(mVV.getVideoWidth(), mVV.getVideoHeight());
                        } else {
                            aspectRatio = new Rational(16, 9);
                        }
                        mPictureInPictureParamsBuilder.setAspectRatio(aspectRatio).build();
                        enterPictureInPictureMode(mPictureInPictureParamsBuilder.build());
                    } else if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.N) {
                        enterPictureInPictureMode();
                    }
                }
            }
        });

        mMusicIcon = findViewById(R.id.music_image);
        mDisableVideoBtn = findViewById(R.id.btn_disable_video);
        mDisableVideoBtn.setOnClickListener(new OnClickListener() {
            @Override
            public void onClick(View v) {
                if (!bLocked) {
                    bVideoDisabled = !bVideoDisabled;
                    mVV.disableVideo(bVideoDisabled);
                    if (bVideoDisabled) {
                        mVV.setVisibility(View.INVISIBLE);
                        mMusicIcon.setVisibility(View.VISIBLE);
                        mDisableVideoBtn.setText("切回视频");

                        if (!bServiceBound) {
                            startPlayerService(getApplicationContext());
                            bServiceBound = true;
                        }
                    } else {
                        mMusicIcon.setVisibility(View.INVISIBLE);
                        mVV.setVisibility(View.VISIBLE);
                        mDisableVideoBtn.setText("听视频");
                        if (bServiceBound) {
                            if (mBgPlayService != null) {
                                mBgPlayService.closeNotification(false);
                            }
                            stopPlayerService(getApplicationContext());
                            bServiceBound = false;
                        }
                    }
                }
            }
        });

        mErrorView = findViewById(R.id.tv_err_msg);
    }

    /**
     * 播放下一个视频源
     * <p>
     * 下一个视频源可以是：
     * 一个全新的视频：反注释下面的reSetRender，清除上一个播放源的最后一帧；
     * 同一视频的另一种分辨率的新链接：1、在stopPlayback之前拿到当前播放位置；2、反注释setInitPlayPosition设置位置；
     */
    private void tryToPlayOther() {
        Log.i(TAG, "tryToPlayOther");
        hideError();
        saveHistory();
        mVV.stopPlayback(); // 释放上一个视频源

        prepareVideoViewForHdrAndVR(info);
        mVV.reSetRender(); // 清除上一个播放源的最后遗留的一帧

        setInitStartPosIfNeeded();
        setScaleModeForVR(info, mVV);

        mVV.setVideoPath(info.getUrl());
        bPreparing = true;
        bPlaybackCompleted = false;
        mVV.start();

        mediaController.clearViewContent();
        mediaController.setViewImage(preImageView, info.getPreImages());
        topTitleView.setText(info.getTitle());
    }

    boolean isPausedByOnPause = false;

    @Override
    protected void onPause() {
        // TODO Auto-generated method stub
        super.onPause();
        Log.i(TAG, "onPause");

        if (!bServiceBound) {
            startPlayerService(getApplicationContext());
            bServiceBound = true;
        }

        // 当home键切出，想暂停视频的话，反注释下面的代码。同时要反注释onResume中的代码
//        if (mVV.isPlaying()) {
//            isPausedByOnPause = true;
//            mVV.pause();
//        }

    }

    @Override
    protected void onResume() {
        // TODO Auto-generated method stub
        super.onResume();
        Log.i(TAG, "onResume");

        bActivityStopped = false;
        if (mOrientation > 350 || mOrientation < 10) {
            changeToPortrait();
        } else if (mOrientation > 80 && mOrientation < 100) {
            changeToLandscape(true);
        } else if (mOrientation > 260 && mOrientation < 280) {
            changeToLandscape(false);
        }

        if (!bVideoDisabled && bServiceBound) {
            if (mBgPlayService != null) {
                mBgPlayService.closeNotification(false);
            }
            stopPlayerService(getApplicationContext());
            bServiceBound = false;
        }

        // 当home键切出，暂停了视频此时想回复的话，反注释下面的代码
//        if (isPausedByOnPause) {
//            isPausedByOnPause = false;
//            mVV.start();
//        }

    }

    @Override
    protected void onRestart() {
        super.onRestart();
        Log.i(TAG, "onRestart");
        showControllers();
        bActivityStopped = false;
    }

    @Override
    protected void onStop() {
        Log.i(TAG, "onStop");
        // enterBackground should be invoke before super.onStop()
        if (mVV != null) {
            saveHistory();
            if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.N
                    && isInPictureInPictureMode()
                    && mVV != null) {
                mVV.stopPlayback();
            }
        }
        bActivityStopped = true;
        super.onStop();
    }

    @Override
    protected void onDestroy() {
        if (mVV != null) {
            Log.i(TAG, "stopPlayback");
            mVV.stopPlayback(); // 释放播放器资源
            mVV.release(); // 释放播放器资源和显示资源
        }
        mVV = null;

        if (mediaController != null) {
            mediaController.release();
        }

        if (bServiceBound) {
            if (mBgPlayService != null) {
                mBgPlayService.closeNotification(true);
            }
            stopPlayerService(getApplicationContext());
            bServiceBound = false;
        }

        Log.i(TAG, "onDestroy");
        disableOrientationListener();
        super.onDestroy();
    }

    @Override
    public void onBackPressed() {
        if (bLocked) {
            return;
        }
        Log.i(TAG, "onBackPressed");
        super.onBackPressed();
    }

    @Override
    public void onPictureInPictureModeChanged(boolean isInPictureInPictureMode,
                                              Configuration newConfig) {
        super.onPictureInPictureModeChanged(isInPictureInPictureMode, newConfig);
        if (isInPictureInPictureMode) {
            hideControllers();
            // Starts receiving events from action items in PiP mode.
            mPipReceiver = new BroadcastReceiver() {
                        @Override
                        public void onReceive(Context context, Intent intent) {
                            if (intent == null
                                    || !ACTION_MEDIA_CONTROL.equals(intent.getAction())) {
                                return;
                            }

                            final int controlType = intent.getIntExtra(EXTRA_CONTROL_TYPE, 0);
                            switch (controlType) {
                                case CONTROL_TYPE_PLAY:
                                    mVV.start();
                                    break;
                                case CONTROL_TYPE_PAUSE:
                                    mVV.pause();
                                    break;
                                default:
                                    break;
                            }
                        }
                    };
            registerReceiver(mPipReceiver, new IntentFilter(ACTION_MEDIA_CONTROL));
        } else {
            unregisterReceiver(mPipReceiver);
            mPipReceiver = null;
            showControllers();
            if (bActivityStopped && mVV != null) {
                saveHistory();
                mVV.stopPlayback();
            }
        }
    }

    private void hideControllers() {
        mediaController.setVisibility(View.GONE);
        fullHeaderRl.setVisibility(View.GONE);
        fullControllerRl.setVisibility(View.GONE);
        normalHeaderRl.setVisibility(View.GONE);
        normalControllerRl.setVisibility(View.GONE);
        headerBar.setVisibility(View.GONE);
        debugInfoScrollView.setVisibility(View.GONE);
        mPipBtn.setVisibility(View.GONE);
        mDisableVideoBtn.setVisibility(View.GONE);
        mGestureView.setVisibility(View.GONE);
        mLockScreen.setVisibility(View.GONE);
    }

    private void showControllers() {
        mediaController.setVisibility(View.VISIBLE);
        headerBar.setVisibility(View.VISIBLE);
        // debugInfoScrollView.setVisibility(View.GONE);
        mPipBtn.setVisibility(View.VISIBLE);
        mDisableVideoBtn.setVisibility(View.VISIBLE);
        mGestureView.setVisibility(View.VISIBLE);
        mLockScreen.setVisibility(View.VISIBLE);
        if (mOrientation > 350 || mOrientation < 10) {
            normalHeaderRl.setVisibility(View.VISIBLE);
            normalControllerRl.setVisibility(View.VISIBLE);
        } else  {
            fullHeaderRl.setVisibility(View.VISIBLE);
            fullControllerRl.setVisibility(View.VISIBLE);
        }
    }

    private void changeToPortrait() {
        Log.d(TAG, "changeToPortrait");
        if (bLocked) {
            return;
        }
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.N) {
            if (isInPictureInPictureMode()) {
                return;
            }
        }
        setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_PORTRAIT);
        FullScreenUtils.toggleHideyBar(AdvancedPlayActivity.this);
        // to mini size, to portrait
        fullHeaderRl.removeAllViews();
        fullControllerRl.removeAllViews();
        normalHeaderRl.removeAllViews();
        normalControllerRl.removeAllViews();
        normalHeaderRl.addView(headerBar);
        normalControllerRl.addView(mediaController);
        normalHeaderRl.setVisibility(View.VISIBLE);
        normalControllerRl.setVisibility(View.VISIBLE);
        RelativeLayout.LayoutParams lp
                = (RelativeLayout.LayoutParams) debugInfoScrollView.getLayoutParams();
        lp.addRule(RelativeLayout.BELOW, R.id.rl_normalscreen_header);
        lp = (RelativeLayout.LayoutParams) mPipBtn.getLayoutParams();
        lp.addRule(RelativeLayout.BELOW, R.id.rl_normalscreen_header);
        lp = (RelativeLayout.LayoutParams) mDisableVideoBtn.getLayoutParams();
        lp.addRule(RelativeLayout.BELOW, R.id.rl_normalscreen_header);
        showControllers();
        isFullScreen = false;
    }

    private void changeToLandscape(boolean reverse) {
        Log.d(TAG, "changeToLandscape");
        if (bLocked) {
            return;
        }
        if (reverse) {
            setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_REVERSE_LANDSCAPE);
        } else {
            setRequestedOrientation(ActivityInfo.SCREEN_ORIENTATION_LANDSCAPE);
        }
        FullScreenUtils.toggleHideyBar(AdvancedPlayActivity.this);
        normalHeaderRl.removeAllViews();
        normalControllerRl.removeAllViews();
        fullHeaderRl.removeAllViews();
        fullControllerRl.removeAllViews();
        fullHeaderRl.addView(headerBar);
        fullControllerRl.addView(mediaController);
        fullHeaderRl.setVisibility(View.VISIBLE);
        fullControllerRl.setVisibility(View.VISIBLE);
        RelativeLayout.LayoutParams lp
                = (RelativeLayout.LayoutParams) debugInfoScrollView.getLayoutParams();
        lp.addRule(RelativeLayout.BELOW, R.id.rl_fullscreen_header);
        lp = (RelativeLayout.LayoutParams) mPipBtn.getLayoutParams();
        lp.addRule(RelativeLayout.BELOW, R.id.rl_fullscreen_header);
        lp = (RelativeLayout.LayoutParams) mDisableVideoBtn.getLayoutParams();
        lp.addRule(RelativeLayout.BELOW, R.id.rl_fullscreen_header);
        isFullScreen = true;
    }

    protected void showError(String errMsg) {
        if (mErrorView == null) {
            mErrorView = findViewById(R.id.tv_err_msg);
        }
        if (mErrorView != null && !TextUtils.isEmpty(errMsg)) {
            mErrorView.setText(errMsg);
            mErrorView.setVisibility(View.VISIBLE);
        }
    }

    protected void hideError() {
        if (mErrorView == null) {
            mErrorView = findViewById(R.id.tv_err_msg);
        }
        if (mErrorView != null) {
            mErrorView.setVisibility(View.GONE);
        }
    }

    /**
     * 检测'点击'空白区的事件，若播放控制控件未显示，设置为显示，否则隐藏。
     */
    public void onClickEmptyArea(View v) {
        if (!isFullScreen) {
            return;
        }
        if (barTimer != null) {
            barTimer.cancel();
            barTimer = null;
        }
        if (this.mediaController != null) {
            if (mediaController.getVisibility() == View.VISIBLE) {
                mediaController.hide();
                debugInfoScrollView.setVisibility(View.GONE);
                headerBar.setVisibility(View.GONE);
                mPipBtn.setVisibility(View.GONE);
                mDisableVideoBtn.setVisibility(View.GONE);
            } else {
                mediaController.show();
//                debugInfoScrollView.setVisibility(View.VISIBLE);
                headerBar.setVisibility(View.VISIBLE);
                mPipBtn.setVisibility(View.VISIBLE);
                mDisableVideoBtn.setVisibility(View.VISIBLE);
                hideOuterAfterFiveSeconds();
            }
        }
    }

    private void enableOrientationListener() {
        mOrientationEventListener = new OrientationEventListener(this) {
            @Override
            public void onOrientationChanged(int orientation) {
                long currentTime = System.currentTimeMillis();
                if (currentTime - mLastOrientationTime < 300) {
                    return;
                }
                mLastOrientationTime = currentTime;

                // 记录用户手机上一次放置的位置
                int lastOrientation = mOrientation;

                if (orientation == OrientationEventListener.ORIENTATION_UNKNOWN) {
                    return;
                }

                if (orientation > 350 || orientation < 10) {
                    if (lastOrientation == 0){
                        return;
                    }
                    mOrientation = 0;
                    changeToPortrait();
                } else if (orientation > 80 && orientation < 100) {
                    if (lastOrientation == 90) {
                        return;
                    }
                    mOrientation = 90;
                    changeToLandscape(true);
                } else if (orientation > 260 && orientation < 280) {
                    if (lastOrientation == 270) {
                        return;
                    }
                    mOrientation = 270;
                    changeToLandscape(false);
                }
            }
        };
        mOrientationEventListener.enable();
    }

    private void disableOrientationListener() {
        if (mOrientationEventListener != null) {
            mOrientationEventListener.disable();
            mOrientationEventListener = null;
        }
    }

    private void hideOuterAfterFiveSeconds() {
        if (!isFullScreen) {
            return;
        }
        if (barTimer != null) {
            barTimer.cancel();
            barTimer = null;
        }
        barTimer = new Timer();
        barTimer.schedule(new TimerTask() {

            @Override
            public void run() {
                if (!isFullScreen) {
                    return;
                }
                if (mediaController != null && mediaController.getMainThreadHandler() != null) {
                    mediaController.getMainThreadHandler().post(new Runnable() {

                        @Override
                        public void run() {
                            mediaController.hide();
                            headerBar.setVisibility(View.GONE);
                            mPipBtn.setVisibility(View.GONE);
                            mDisableVideoBtn.setVisibility(View.GONE);
                        }

                    });
                }
            }

        }, 5 * 1000);

    }

    @Override
    public boolean onInfo(IMediaPlayer mp, int what, int extra) {
        if (what == IMediaPlayer.MEDIA_INFO_VIDEO_RENDERING_START) {
            // updateTextInfo("First frame cost: " + extra + "ms");
        } else if (what == IMediaPlayer.MEDIA_INFO_BUFFERING_START) {
            updateTextInfo("Buffering Start");
            bufferingStartTimeMs = SystemClock.elapsedRealtime();
        } else if (what == IMediaPlayer.MEDIA_INFO_BUFFERING_END) {
            updateTextInfo("Bufffering End, buffering time: "
                    + (SystemClock.elapsedRealtime() - bufferingStartTimeMs) + " ms");
        } else if (what == IMediaPlayer.MEDIA_INFO_FRAMECHASING_START) {
            updateTextInfo("Frame chasing Start");
        } else if (what == IMediaPlayer.MEDIA_INFO_FRAMECHASING_END) {
            updateTextInfo("Frame chasing End");
        }
        return false;
    }

    @Override
    public boolean onSEI(IMediaPlayer mp, byte[] seiMessage) {
       Log.d(TAG, "onSEI length : " + seiMessage.length);

        String s = new String(seiMessage);
        if (s.startsWith("<svg")) {
            mDanmuView.setSvgMaskData(s);
        } else if (s.startsWith("<?xml")) {
            String svg = s.substring(s.indexOf("<svg"));
            mDanmuView.setSvgMaskData(svg);
        }
//        Log.e("SEI", "AdvancedPlay SEI: " + s);
//
//        s = "SEI Message: " + s;
//
//        Toast.makeText(this, s.length() > 50 ? s.substring(0, 50) : s, Toast.LENGTH_LONG).show();

        return true;
    }

    @Override
    public String onHlsSegmentRequest(IMediaPlayer mp, String oriUrl) {
        // return oriUrl + "?ts=12345";
        return oriUrl;
    }

    @Override
    public boolean onError(IMediaPlayer mp, int what, int extra) {
        showError(CommonUtils.getReadableErrorMsg(what, extra));
        return false;
    }

    @Override
    public void onCompletion(IMediaPlayer mp) {
        bPlaybackCompleted = true;
        saveHistory();
    }

    @Override
    public void onPrepared(IMediaPlayer mp) {
        bPreparing = false;
        mNowPlaying.duration = mVV.getDuration();
        updateTextInfo("onPrepared");
        hideError();
    }

    @Override
    public void onVideoSizeChanged(IMediaPlayer mp, int width, int height, int sarNum, int sarDen) {
        updateTextInfo("onVideoSizeChanged width: " + width + ", height: " + height);
    }

    @Override
    public void onBufferingUpdate(IMediaPlayer mp, int percent) {
//        Log.d(TAG, "onBufferingUpdate percent=" + percent);
        if (mediaController != null && mVV != null) {
            mediaController.onTotalCacheUpdate(percent * mVV.getDuration() / 100);
        }
    }

    @Override
    public void onPlayerStateChanged(PlayerState nowState) {
        if (mediaController != null) {
            mediaController.changeState();
        }

        switch (nowState) {
            case STATE_IDLE:
            case STATE_ERROR:
                if (mDanmuView != null) {
                    mDanmuView.release();
                }
                break;
            case STATE_PREPARING:
                if (mDanmuView != null) {
                    if (SharedPrefsStore.getBooleanData(this, C.KEY_AUTORESUME_SWITCH)
                            && isResumePosValid(mNowPlaying.position, mNowPlaying.duration)) {
                        mDanmuView.prepare(mNowPlaying.position);
                    } else {
                        mDanmuView.prepare();
                    }
                }
                break;
            case STATE_PREPARED:
                break;
            case STATE_PLAYING:
                if (mDanmuView != null) {
                    mDanmuView.start();
                }
                break;
            case STATE_PAUSED:
                if (mDanmuView != null) {
                    mDanmuView.pause();
                }
                break;
            case STATE_PLAYBACK_COMPLETED:
                if (mDanmuView != null) {
                    mDanmuView.release();
                }
                break;
        }
    }

    @Override
    public void onCastStateChanged(int state) {
        if (state == CAST_START) {
            showError("投屏中");
        } else if (state == CAST_END) {
            showError("投屏结束");
        }
    }

    @Override
    public void onVideoRenderSurfaceChanged(int w, int h) {
        if (mDanmuView != null) {
            Rect rect = mVV.getVideoRenderRect();
            mDanmuView.setVideoViewRecf(new RectF(rect));
        }
    }

    private void setInitStartPosIfNeeded() {
        mNowPlaying = new MediaBean();
        mNowPlaying.path = info.getUrl();
        restoreFromHistory(mNowPlaying);
        if (SharedPrefsStore.getBooleanData(this, C.KEY_AUTORESUME_SWITCH)
                && isResumePosValid(mNowPlaying.position, mNowPlaying.duration)) {
            mVV.setInitPlayPosition(mNowPlaying.position);
        }
    }

    private boolean isResumePosValid(int pos, int duration) {
        return pos > C.AUTO_RESUME_TIME_THRESHOLD
                && (duration <= 0 || pos < duration - C.AUTO_RESUME_TIME_THRESHOLD);
    }

    private void restoreFromHistory(MediaBean item) {
        List<MediaBean> historyList = DBManager.getInstance().queryHistory();
        for (MediaBean history : historyList) {
            if (!TextUtils.isEmpty(item.path) && !TextUtils.isEmpty(history.path)
                    && item.path.contentEquals(history.path)) {
                item.id = history.id;
                item.position = history.position;
                item.duration = history.duration;
                break;
            }
        }
    }

    private void saveHistory() {
        if (mNowPlaying != null && mVV != null && !bPreparing) {
            if (bPlaybackCompleted) {
                mNowPlaying.position = mNowPlaying.duration;
            } else {
                if (mVV.getCurrentPosition() >= 0) {
                    mNowPlaying.position = mVV.getCurrentPosition();
                } else {
                    return;
                }
            }
            DBManager.getInstance().updateHistory(mNowPlaying);
        }
    }

    private void updateTextInfo(String text) {
        if (debugInfoTextView.getText().length() > 1500) {
            debugInfoTextView.setText("");
        }
        debugInfoTextView.setText(debugInfoTextView.getText() + text + "\n");
        debugInfoScrollView.fullScroll(ScrollView.FOCUS_DOWN);
    }

    private void prepareVideoViewForHdrAndVR(VideoInfo info) {
        if (info.isVrEnable()) {
            try {
                if (FeatureManager.getInstance().checkVrFeatureValid(this, BaseApp.APP_ID)) {
                    BDCloudVideoView.setVrEnable(info.isVrEnable());
                }
            } catch (FeatureException e) {
                if (e.getFeatureErrCode() == FeatureException.FEATURE_ERR_LICENSE_INVALID) {
                    Toast.makeText(this, "当前License不支持VR播放", Toast.LENGTH_SHORT).show();
                } else {
                    Toast.makeText(this, "当前SDK不支持VR播放功能", Toast.LENGTH_SHORT).show();
                }
                BDCloudVideoView.setVrEnable(false);
            }
        } else {
            BDCloudVideoView.setVrEnable(false);
        }
        if (info.isHdrEnable()) {
            try {
                if (FeatureManager.getInstance().checkHdrFeatureValid(this, BaseApp.APP_ID)) {
                    if (CommonUtils.getSmartVisionType(this) != C.SMARTVISION_HDR) {
                        Toast.makeText(this, "进入设置打开智感超清-HDR，感受震撼HDR效果", Toast.LENGTH_SHORT).show();
                    }
                }
            } catch (FeatureException e) {
                Log.e(TAG, "HDR feature not supported " + e.getFeatureErrMsg());
            }
        }
    }

    private void setScaleModeForVR(VideoInfo info, BDCloudVideoView videoView) {
        if (info.isVrEnable()) {
            videoView.setVideoScalingMode(BDCloudVideoView.VIDEO_SCALING_MODE_SCALE_TO_FIT_WITH_CROPPING);
        } else {
            if (SharedPrefsStore.isPlayerFitModeCrapping(getApplicationContext())) {
                videoView.setVideoScalingMode(BDCloudVideoView.VIDEO_SCALING_MODE_SCALE_TO_FIT_WITH_CROPPING);
            } else {
                videoView.setVideoScalingMode(BDCloudVideoView.VIDEO_SCALING_MODE_SCALE_TO_FIT);
            }
        }
    }

    private ServiceConnection connection = new ServiceConnection() {
        @Override
        public void onServiceConnected(ComponentName name, IBinder service) {
            mBgPlayBinder = (BackgroundPlayService.BackgroundPlayBinder) service;
            mBgPlayService = mBgPlayBinder.getService();
            mBgPlayService.setMediaController(mediaController);
            mBgPlayService.setTitle(info.getTitle());
            mBgPlayService.updateProgress();
        }

        @Override
        public void onServiceDisconnected(ComponentName name) {
            mBgPlayBinder = null;
        }
    };

    private void listenToNetworkChange() {
        ConnectivityManager connectivityManager = (ConnectivityManager) getSystemService(Context.CONNECTIVITY_SERVICE);
        if (connectivityManager != null) {
            NetworkRequest.Builder builder = new NetworkRequest.Builder();

            NetworkRequest request = builder.addCapability(NetworkCapabilities.NET_CAPABILITY_INTERNET)
                    .addTransportType(NetworkCapabilities.TRANSPORT_WIFI)
                    .addTransportType(NetworkCapabilities.TRANSPORT_ETHERNET)
                    .build();
            connectivityManager.registerNetworkCallback(request, new ConnectivityManager.NetworkCallback() {
                @Override
                public void onAvailable(Network network) {
                    Log.i(TAG, "NetworkCallback onAvailable");
                    super.onAvailable(network);
                }

                @Override
                public void onLost(Network network) {
                    // 同时链接wifi和ethernet，只拔ethernet，也会有onLost回调
                    Log.i(TAG, "NetworkCallback onLost");
                    super.onLost(network);
                    if (!CommonUtils.checkNetwork(getApplicationContext())) {
                        Toast.makeText(getApplicationContext(), "网络断开", Toast.LENGTH_LONG).show();
                    }
                }
            });
        }
    }

    private void startPlayerService(Context context) {
        Intent serviceIntent = new Intent(context, BackgroundPlayService.class);
        if (Build.VERSION.SDK_INT >= Build.VERSION_CODES.O) {
            context.startForegroundService(serviceIntent);
        } else {
            context.startService(serviceIntent);
        }
        bindService(serviceIntent, connection, 0);
    }

    private void stopPlayerService(Context context) {
        Intent serviceIntent = new Intent(context, BackgroundPlayService.class);
        unbindService(connection);
        stopService(serviceIntent);
    }
}
