package com.baidu.cloud.videoplayer.demo.datasource;

import java.io.IOException;
import java.io.InputStream;

import com.baidu.cloud.media.player.misc.IMediaDataSource;

import android.util.Log;

public class ExtDataSourceProvider implements IMediaDataSource {

    private static final String TAG = "ExtDataSourceProvider";
    private InputStream mInputStream;
    private long mPosition = 0;
    public ExtDataSourceProvider(InputStream is) {
        this.mInputStream = is;
    }

    @Override
    public int readAt(long position, byte[] buffer, int offset, int size) throws IOException {
        if (size <= 0)
            return size;
        if (mPosition != position) {
            mInputStream.reset();
            mPosition = mInputStream.skip(position);
            Log.w(TAG, "Seek pos to " + mPosition);
        }
        int length = mInputStream.read(buffer, offset, size);
        mPosition += length;
        Log.w(TAG, "Current Pos " + mPosition + " read length: " + length);
        return length;

    }

    @Override
    public long getSize() throws IOException {
        Log.w(TAG, "data available length: " + mInputStream.available());
        return mInputStream.available();
    }

    @Override
    public void close() throws IOException {
        if (mInputStream != null) {
            mInputStream.close();
        }
        mInputStream = null;
    }
}