package com.baidu.cloud.videoplayer.demo.db;

import android.content.Context;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteDatabase.CursorFactory;
import android.database.sqlite.SQLiteOpenHelper;

public class SQLiteHelper extends SQLiteOpenHelper {
    private static final String HISTORY_TABLE_CREATE = "CREATE TABLE IF NOT EXISTS " +
            MediaProvider.TABLE_HISTORY + "(" +
            MediaBean.BEAN_ID + " integer primary key," +
            MediaBean.BEAN_PATH + " varchar," +
            MediaBean.BEAN_POSITION + " INTEGER," +
            MediaBean.BEAN_DURATION + " INTEGER" +
            ")";

    public SQLiteHelper(Context context, String name, CursorFactory factory,
                        int version) {
        super(context, name, factory, version);
    }

    @Override
    public void onCreate(SQLiteDatabase db) {
        db.execSQL(HISTORY_TABLE_CREATE);
    }

    @Override
    public void onUpgrade(SQLiteDatabase db, int oldVersion, int newVersion) {
        if (oldVersion == 1 && newVersion == 2) {
            final String TEMP_TABLE_CREATE = "CREATE TABLE IF NOT EXISTS TempTable" +
                    "(" +
                    MediaBean.BEAN_ID + " integer primary key," +
                    MediaBean.BEAN_PATH + " varchar," +
                    MediaBean.BEAN_POSITION + " INTEGER," +
                    MediaBean.BEAN_DURATION + " INTEGER" +
                    ")";
            db.execSQL(TEMP_TABLE_CREATE);
            db.execSQL("INSERT INTO TempTable SELECT * FROM " + MediaProvider.TABLE_HISTORY);
            db.execSQL("DROP TABLE " + MediaProvider.TABLE_HISTORY);
            db.execSQL("ALTER TABLE TempTable RENAME TO " + MediaProvider.TABLE_HISTORY);
        }
    }

    @Override
    public void onDowngrade(SQLiteDatabase db, int oldVersion, int newVersion) {
        db.execSQL("DROP TABLE IF EXISTS " + MediaProvider.TABLE_HISTORY);
        onCreate(db);
    }
}
